function resetRanks()
{
   g_rank_snot = 1;
   xp_snot = 0;
   xp_max_snot = g_rank_factor;
   xp_bar_snot.bar._width = 0;
   g_rank_fire = 1;
   xp_fire = 0;
   xp_max_fire = g_rank_factor;
   xp_bar_fire.bar._width = 0;
   g_rank_ice = 1;
   xp_ice = 0;
   xp_max_ice = g_rank_factor;
   xp_bar_ice.bar._width = 0;
   g_rank_steel = 1;
   xp_steel = 0;
   xp_max_steel = g_rank_factor;
   xp_bar_steel.bar._width = 0;
   g_rank_greese = 1;
   xp_greese = 0;
   xp_max_greese = g_rank_factor;
   xp_bar_greese.bar._width = 0;
   g_rank_meteor = 1;
   xp_meteor = 0;
   xp_max_meteor = g_rank_factor;
   xp_bar_meteor.bar._width = 0;
}
function initGameVars()
{
   g_levelTimer = 2000;
   g_level = 1;
   g_dragon_hp = 100;
   g_dragon_max_hp = 100;
   g_score = 0;
   resetRanks();
}
function updateDragonHPBar()
{
   dragon_hp.bar._width = g_dragon_hp / g_dragon_max_hp * 100;
}
function deltaDragonHP(amt)
{
   var _loc2_ = 0;
   if(amt < 0)
   {
      playSound("dragon_hurt4.wav");
   }
   g_dragon_hp += amt;
   if(g_dragon_hp > g_dragon_max_hp)
   {
      _loc2_ = g_dragon_hp - g_dragon_max_hp;
      g_dragon_hp = g_dragon_max_hp;
      returnVal = amt - _loc2_;
   }
   else if(g_dragon_hp < 0)
   {
      g_dragon_hp = 0;
      returnVal = amt;
   }
   else
   {
      returnVal = amt;
   }
   if(g_dragon_hp <= 0)
   {
      gameOver();
   }
   updateDragonHPBar();
   return returnVal;
}
function getRandomPlankDebris()
{
   return plankDebris[random(plankDebris.length)];
}
function woodExplosion(xpos, ypos, amt)
{
   var _loc3_ = undefined;
   var _loc1_ = undefined;
   var _loc2_ = 0;
   while(_loc2_ < amt)
   {
      _loc3_ = getRandomPlankDebris();
      _loc1_ = addObj(_loc3_,debris_layer,getNextDebrisLevel());
      _loc1_._x = xpos;
      _loc1_._y = ypos;
      _loc1_._rotation = random(360);
      _loc2_ = _loc2_ + 1;
   }
}
function addFlyingTroop(troop, xpos, ypos, xscale, yscale)
{
   var _loc1_ = undefined;
   _loc1_ = addObj(troop,debris_layer,getNextDebrisLevel());
   _loc1_._x = xpos;
   _loc1_._y = ypos;
   _loc1_._xscale = xscale;
   _loc1_._yscale = yscale;
   _loc1_._rotation = random(360);
}
function getWrapNdx(val)
{
   temp_ndx = sndx + val;
   if(temp_ndx < 0)
   {
      temp_ndx = max_ndx + temp_ndx;
   }
   return temp_ndx;
}
function updateSpine()
{
   if(sndx++ >= max_ndx - 1)
   {
      sndx = 0;
   }
   xspine[sndx] = dragon_head._x;
   yspine[sndx] = dragon_head._y;
   rotspin[sndx] = dragon_head._rotation;
   ztwist[sndx] = dragon_head._zrot;
}
function placeOnSpine(obj)
{
   var _loc2_ = undefined;
   ndx = getWrapNdx(obj.offset);
   obj._x = xspine[ndx];
   obj._y = yspine[ndx];
   obj._rotation = rotspin[ndx];
   _loc2_ = Math.ceil(ztwist[ndx] / 360 * 170);
   obj.body.gotoAndStop(_loc2_);
}
function shoot()
{
   if(g_ammo_fire > 0 && g_shoot_mode == FIRE_MODE || g_ammo_ice > 0 && g_shoot_mode == ICE_MODE || g_ammo_greese > 0 && g_shoot_mode == GREESE_MODE || g_ammo_steel > 0 && g_shoot_mode == STEEL_MODE || g_ammo_snot > 0 && g_shoot_mode == SNOT_MODE || g_ammo_meteor > 0 && g_shoot_mode == METEOR_MODE)
   {
      power = 16;
      rads = (dragon_head._rotation + 180) * 3.141592653589793 / 180;
      xfactor = Math.cos(rads);
      yfactor = Math.sin(rads);
      lvx = power * xfactor;
      lvy = power * yfactor;
      lvl = getNextProjectileLevel();
      var _loc1_ = undefined;
      var _loc2_ = undefined;
      if(g_shoot_mode == FIRE_MODE)
      {
         _loc1_ = addObj("flame_ball",bullet_layer,lvl);
         g_ammo_fire--;
         _loc2_ = g_rank_fire;
      }
      else if(g_shoot_mode == ICE_MODE)
      {
         _loc1_ = addObj("ice_ball",bullet_layer,lvl);
         g_ammo_ice--;
         _loc2_ = g_rank_ice;
      }
      else if(g_shoot_mode == METEOR_MODE)
      {
         _loc1_ = addObj("meteor_ball",bullet_layer,lvl);
         _loc2_ = g_rank_meteor;
         g_ammo_meteor--;
      }
      else if(g_shoot_mode == STEEL_MODE)
      {
         _loc1_ = addObj("steel_ball",bullet_layer,lvl);
         g_steel_balls.push(_loc1_);
         lvx *= 0.5;
         lvy *= 0.5;
         _loc2_ = g_rank_steel;
         g_ammo_steel--;
      }
      else if(g_shoot_mode == SNOT_MODE)
      {
         _loc1_ = addObj("snot_ball",bullet_layer,lvl);
         _loc2_ = g_rank_snot;
         g_ammo_snot--;
      }
      else if(g_shoot_mode == GREESE_MODE)
      {
         _loc1_ = addObj("greese_ball",bullet_layer,lvl);
         _loc2_ = g_rank_greese;
         g_ammo_greese--;
      }
      if(g_shoot_mode != STEEL_MODE)
      {
         _loc1_._xscale = _loc1_._yscale = 30 + _loc2_ * 20;
      }
      _loc1_.rank = _loc2_;
      _loc1_.vx = lvx;
      _loc1_.vy = lvy;
      _loc1_._x = dragon_head._x + xfactor * 20;
      _loc1_._y = dragon_head._y + yfactor * 20;
      _loc1_._rotation = dragon_head._rotation + 180;
      playSound("swoosh.wav");
   }
   else
   {
      playSound("dragon_hurt4.wav");
   }
}
function shootAtDragon(xpos, ypos, speed)
{
   speed = 1 + g_level / 33;
   if(speed > 3)
   {
      speed = 3;
   }
   var _loc5_ = undefined;
   var _loc4_ = undefined;
   var _loc3_ = undefined;
   var _loc2_ = undefined;
   _loc3_ = dragon_head._x - xpos;
   _loc2_ = dragon_head._y - ypos;
   dist = Math.sqrt(_loc3_ * _loc3_ + _loc2_ * _loc2_);
   _loc5_ = _loc3_ / dist * speed;
   _loc4_ = _loc2_ / dist * speed;
   lvl = getNextProjectileLevel();
   p_type = "";
   if(random(2) == 0)
   {
      p_type = "proj_enemy_fire";
   }
   else
   {
      p_type = "proj_enemy_ice";
   }
   proj = addObj(p_type,bullet_layer,lvl);
   proj.vx = _loc5_;
   proj.vy = _loc4_;
   proj._x = xpos;
   proj._y = ypos;
}
function shootAtDragonProjectile(xpos, ypos, speed, p_type)
{
   speed = 1 + g_level / 33;
   if(speed > 3)
   {
      speed = 3;
   }
   var _loc5_ = undefined;
   var _loc4_ = undefined;
   var _loc3_ = undefined;
   var _loc2_ = undefined;
   _loc3_ = dragon_head._x - xpos;
   _loc2_ = dragon_head._y - ypos;
   dist = Math.sqrt(_loc3_ * _loc3_ + _loc2_ * _loc2_);
   _loc5_ = _loc3_ / dist * speed;
   _loc4_ = _loc2_ / dist * speed;
   if(p_type == "proj_enemy_steel")
   {
      lvl = getNextEnemyLevel();
      proj = addObj(p_type,bullet_layer,lvl);
      addEnemy(proj);
   }
   else
   {
      lvl = getNextProjectileLevel();
      proj = addObj(p_type,bullet_layer,lvl);
   }
   proj.vx = _loc5_;
   proj.vy = _loc4_;
   proj._x = xpos;
   proj._y = ypos;
}
function twistDragon()
{
   dragon_head.switchDiff();
}
function getNextProjectileLevel()
{
   if(proj_lvl++ > 15)
   {
      proj_lvl = 1;
   }
   return proj_lvl;
}
function getNextStickyLevel()
{
   if(sticky_lvl++ > 15)
   {
      sticky_lvl = 1;
   }
   return sticky_lvl;
}
function addObj(obj, layer, lvl)
{
   temp = layer.attachMovie(obj,obj + "_id_" + getIDNum(),lvl);
   return temp;
}
function getIDNum()
{
   return id_num++;
}
function getNextEnemyLevel()
{
   return ene_lvl++;
}
function addEnemy(ene)
{
   enemies.push(ene);
}
function removeEnemy(ene)
{
   var _loc2_ = undefined;
   var _loc3_ = -1;
   var _loc1_ = 0;
   while(_loc1_ < enemies.length)
   {
      _loc2_ = enemies[_loc1_];
      if(_loc2_ == ene)
      {
         _loc3_ = _loc1_;
         break;
      }
      _loc1_ = _loc1_ + 1;
   }
   if(_loc3_ != -1)
   {
      enemies.splice(_loc3_,1);
   }
   _loc2_.unloadMovie();
}
function addDragonPart(obj)
{
   m_dragonParts.push(obj);
}
function testHitDragon(obj)
{
   var _loc4_ = false;
   var _loc3_ = undefined;
   var _loc1_ = 0;
   while(_loc1_ < m_dragonParts.length && !_loc4_)
   {
      _loc3_ = m_dragonParts[_loc1_];
      _loc4_ = _loc3_.hitBox.hitTest(obj._x,obj._y,1);
      _loc1_ = _loc1_ + 1;
   }
   if(_loc4_)
   {
      var _loc5_ = 0;
      var _loc7_ = "";
      if(obj.m_type == "fire")
      {
         if(_loc3_.body.hitBox_fire.hitTest(obj._x,obj._y,1))
         {
            deflectObject(_loc3_._rotation,obj,"meteor_ball",0);
            _loc5_ = 20;
         }
         else
         {
            deltaDragonHP(-1 - Math.floor(g_level / 2));
            _loc5_ = obj._xscale;
         }
         _loc7_ = "explosion_pow";
         playSound("bomb.wav");
      }
      else if(obj.m_type == "ice")
      {
         if(_loc3_.body.hitBox_ice.hitTest(obj._x,obj._y,1))
         {
            deflectObject(_loc3_._rotation,obj,"ice_ball",0);
            _loc5_ = 20;
         }
         else
         {
            deltaDragonHP(-1 - Math.floor(g_level / 2));
            _loc5_ = obj._xscale;
         }
         _loc7_ = "explosion_pow_ice";
         playSound("ice_shatter.wav");
      }
      else if(obj.m_type == "steel")
      {
         deltaDragonHP(-1 - Math.floor(g_level / 1.5));
         _loc7_ = "explosion_pow";
         _loc5_ = obj._xscale * 1.5;
         playSound("bomb_hit.wav");
      }
      if(_loc7_ != "")
      {
         var _loc6_ = addObj(_loc7_,debris_layer,getNextDebrisLevel());
         _loc6_._x = obj._x;
         _loc6_._y = obj._y;
         _loc6_._xscale = _loc6_._yscale = _loc5_;
         _loc6_._rotation = random(360);
      }
      obj.destroy();
   }
}
function deflectObject(rot, obj, projName, angleOffset)
{
   var _loc3_ = getReflectionAngle(rot,obj.vx,obj.vy);
   var _loc5_ = Math.sqrt(obj.vx * obj.vx + obj.vy + obj.vy);
   var _loc2_ = addObj(projName,bullet_layer,getNextProjectileLevel());
   _loc2_.vx = Math.cos(0.017453292519943295 * _loc3_ + angleOffset) * 5;
   _loc2_.vy = Math.sin(0.017453292519943295 * _loc3_ + angleOffset) * 5;
   _loc2_.rank = 1;
   _loc2_._x = obj._x;
   _loc2_._y = obj._y;
   playSound("ching2.wav");
}
function deltaFireAmmo(amt)
{
   g_ammo_fire += amt;
   if(g_ammo_fire < 0)
   {
      g_ammo_fire = 0;
   }
}
function deltaIceAmmo(amt)
{
   g_ammo_ice += amt;
   if(g_ammo_ice < 0)
   {
      g_ammo_ice = 0;
   }
}
function deltaGreeseAmmo(amt)
{
   g_ammo_greese += amt;
   if(g_ammo_greese < 0)
   {
      g_ammo_greese = 0;
   }
}
function deltaMeteorAmmo(amt)
{
   g_ammo_meteor += amt;
   if(g_ammo_meteor < 0)
   {
      g_ammo_meteor = 0;
   }
}
function deltaSnotAmmo(amt)
{
   g_ammo_snot += amt;
   if(g_ammo_snot < 0)
   {
      g_ammo_snot = 0;
   }
}
function deltaSteelAmmo(amt)
{
   g_ammo_steel += amt;
   if(g_ammo_steel < 0)
   {
      g_ammo_steel = 0;
   }
}
function updateSpeed()
{
   d_speed = in_speed;
   d_turn_rate = d_speed * 0.3;
   dragon_head.g_missile_turn_rate = d_turn_rate;
   dragon_head.g_missile_speed = d_speed;
}
function getNextDebrisLevel()
{
   if(debris_lvl++ > 100)
   {
      debris_lvl = 1;
   }
   return debris_lvl;
}
function getNextAmmoLevel()
{
   if(ammo_lvl++ > 7)
   {
      ammo_lvl = 1;
   }
   return ammo_lvl;
}
function getNextScoreLevel()
{
   if(score_lvl++ > 10)
   {
      score_lvl = 1;
   }
   return score_lvl;
}
function testHitShips(obj)
{
   var _loc4_ = false;
   var _loc1_ = undefined;
   var _loc3_ = 0;
   while(_loc3_ < enemies.length && !_loc4_)
   {
      _loc1_ = enemies[_loc3_];
      if(_loc1_ != obj && _loc1_.hitTest(obj))
      {
         _loc4_ = true;
         if(!_loc1_.isDead())
         {
            _loc1_.takeDamage(1000);
            obj = addObj("explosion_pow",debris_layer,getNextDebrisLevel());
            obj._x = _loc1_._x;
            obj._y = _loc1_._y;
            obj._rotation = random(360);
         }
      }
      _loc3_ = _loc3_ + 1;
   }
}
function addSmoke(xpos, ypos)
{
   var _loc1_ = addObj("smoke",debris_layer,getNextDebrisLevel());
   _loc1_._x = xpos;
   _loc1_._y = ypos;
   _loc1_._rotation = random(360);
}
function addDebris(dType, xpos, ypos, rot, scale)
{
   var _loc1_ = addObj(dType,debris_layer,getNextDebrisLevel());
   _loc1_._x = xpos;
   _loc1_._y = ypos;
   _loc1_._rotation = rot;
   _loc1_._xscale = _loc1_._yscale = scale;
   return _loc1_;
}
function resetButtonIndicators()
{
   fire_button.gotoAndStop(1);
   ice_button.gotoAndStop(1);
   meteor_button.gotoAndStop(1);
   snot_button.gotoAndStop(1);
   greese_button.gotoAndStop(1);
   steel_button.gotoAndStop(1);
}
function switchToFire()
{
   g_shoot_mode = FIRE_MODE;
   g_shoot_mode_text = "fire ball";
   resetButtonIndicators();
   fire_button.gotoAndStop(2);
}
function switchToIce()
{
   g_shoot_mode = ICE_MODE;
   g_shoot_mode_text = "ice ball";
   resetButtonIndicators();
   ice_button.gotoAndStop(2);
}
function switchToMeteor()
{
   g_shoot_mode = METEOR_MODE;
   g_shoot_mode_text = "meteor ball";
   resetButtonIndicators();
   meteor_button.gotoAndStop(2);
}
function switchToSnot()
{
   g_shoot_mode = SNOT_MODE;
   g_shoot_mode_text = "snot ball";
   resetButtonIndicators();
   snot_button.gotoAndStop(2);
}
function switchToGreese()
{
   g_shoot_mode = GREESE_MODE;
   g_shoot_mode_text = "greese ball";
   resetButtonIndicators();
   greese_button.gotoAndStop(2);
}
function switchToSteel()
{
   g_shoot_mode = STEEL_MODE;
   g_shoot_mode_text = "steel ball";
   resetButtonIndicators();
   steel_button.gotoAndStop(2);
}
function detonateSteel()
{
   var _loc3_ = undefined;
   var _loc5_ = undefined;
   var _loc6_ = 0;
   var _loc2_ = undefined;
   var _loc4_ = 0;
   while(_loc4_ < g_steel_balls.length)
   {
      _loc2_ = g_steel_balls[_loc4_];
      _loc3_ = _loc2_.rank + 1;
      _loc5_ = 360 / _loc3_;
      if(_loc3_ == 7)
      {
         lvl = getNextProjectileLevel();
         proj = addObj("steel_ball_single",bullet_layer,lvl);
         proj.vx = _loc2_.vx;
         proj.vy = _loc2_.vy;
         proj._x = _loc2_._x;
         proj._y = _loc2_._y;
      }
      var _loc1_ = 0;
      while(_loc1_ < _loc3_)
      {
         addSteelBall(_loc2_,_loc1_ * _loc5_);
         _loc1_ = _loc1_ + 1;
      }
      _loc2_.unloadMovie();
      _loc4_ = _loc4_ + 1;
   }
   playSound("deflect.wav");
   g_steel_balls = new Array();
}
function addSteelBall(tempBall, degreeOffset)
{
   power = 2;
   rads = (degreeOffset + tempBall._rotation - 90) * 3.141592653589793 / 180;
   xfactor = Math.cos(rads);
   yfactor = Math.sin(rads);
   lvx = power * xfactor;
   lvy = power * yfactor;
   lvl = getNextProjectileLevel();
   proj = addObj("steel_ball_single",bullet_layer,lvl);
   proj.vx = lvx + tempBall.vx;
   proj.vy = lvy + tempBall.vy;
   proj._x = tempBall._x + xfactor * 5;
   proj._y = tempBall._y + yfactor * 5;
}
function removeFromSteelBalls(clip)
{
   var _loc2_ = undefined;
   var _loc3_ = -1;
   var _loc1_ = 0;
   while(_loc1_ < g_steel_balls.length)
   {
      _loc2_ = g_steel_balls[_loc1_];
      if(_loc2_ == clip)
      {
         _loc3_ = _loc1_;
         break;
      }
      _loc1_ = _loc1_ + 1;
   }
   if(_loc3_ != -1)
   {
      g_steel_balls.splice(_loc3_,1);
   }
}
function addSticky(stickyName, obj, xp, yp, sz)
{
   var _loc3_ = getNextStickyLevel();
   var _loc1_ = addObj(stickyName,sticky_layer,_loc3_);
   _loc1_.x_offset = xp - obj._x;
   _loc1_.y_offset = yp - obj._y;
   _loc1_.m_size = sz;
   _loc1_._xscale = _loc1_._yscale = 0;
   _loc1_.stuckTo = obj;
   _loc1_._x = xp;
   _loc1_._y = yp;
   _loc1_.stype = stickyName;
   obj.updateStickies(_loc1_);
   checkStickyReactions(obj,_loc1_);
}
function checkStickyReactions(obj, stick)
{
   var _loc2_ = undefined;
   var _loc3_ = 0;
   while(_loc3_ < obj.m_stickies.length)
   {
      _loc2_ = obj.m_stickies[_loc3_];
      if(_loc2_ != stick)
      {
         if(stick.stype == "sticky_ice" && _loc2_.stype == "sticky_fire")
         {
            stick.m_size = _loc2_.m_size = 1;
         }
         else if(stick.stype == "sticky_fire" && _loc2_.stype == "sticky_ice")
         {
            stick.m_size = _loc2_.m_size = 1;
         }
         else if(stick.stype == "sticky_fire" && _loc2_.stype == "sticky_greese")
         {
            stick.m_size *= 1.5;
            _loc2_.m_size = 1;
            var _loc4_ = addObj("explosion_pow",debris_layer,getNextDebrisLevel());
            _loc4_._x = stick._x;
            _loc4_._y = stick._y;
            _loc4_._rotation = random(360);
         }
         else if(stick.stype == "sticky_greese" && _loc2_.stype == "sticky_fire")
         {
            _loc2_.m_size *= 1.5;
            stick.m_size = 1;
            _loc4_ = addObj("explosion_pow",debris_layer,getNextDebrisLevel());
            _loc4_._x = stick._x;
            _loc4_._y = stick._y;
            _loc4_._rotation = random(360);
         }
      }
      _loc3_ = _loc3_ + 1;
   }
}
function updateRankSteel(amt)
{
   xp = g_width / 2;
   yp = g_ground / 2;
   if(g_rank_steel < 6)
   {
      if((xp_steel += amt) > xp_max_steel)
      {
         xp_steel -= xp_max_steel;
         g_rank_steel++;
         xp_max_steel = g_rank_steel * g_rank_factor;
         var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
         _loc1_._x = xp;
         _loc1_._y = yp;
         _loc1_.val = "steel level up!";
         playSound("level_up03.wav");
      }
      if(g_rank_steel < 6)
      {
         xp_bar_steel.bar._width = xp_steel / xp_max_steel * 100;
      }
      else
      {
         xp_bar_steel.bar.gotoAndStop(2);
         xp_bar_steel.bar._width = 100;
      }
   }
}
function updateRankFire(amt)
{
   xp = g_width / 2;
   yp = g_ground / 2;
   if(g_rank_fire < 6)
   {
      if((xp_fire += amt) > xp_max_fire)
      {
         xp_fire -= xp_max_fire;
         g_rank_fire++;
         xp_max_fire = g_rank_fire * g_rank_factor;
         var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
         _loc1_._x = xp;
         _loc1_._y = yp;
         _loc1_.val = "fire level up!";
         playSound("level_up03.wav");
      }
      if(g_rank_fire < 6)
      {
         xp_bar_fire.bar._width = xp_fire / xp_max_fire * 100;
      }
      else
      {
         xp_bar_fire.bar.gotoAndStop(2);
         xp_bar_fire.bar._width = 100;
      }
   }
}
function updateRankIce(amt)
{
   xp = g_width / 2;
   yp = g_ground / 2;
   if(g_rank_ice < 6)
   {
      if((xp_ice += amt) > xp_max_ice)
      {
         xp_ice -= xp_max_ice;
         g_rank_ice++;
         xp_max_ice = g_rank_ice * g_rank_factor;
         var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
         _loc1_._x = xp;
         _loc1_._y = yp;
         _loc1_.val = "ice level up!";
         playSound("level_up03.wav");
      }
      if(g_rank_ice < 6)
      {
         xp_bar_ice.bar._width = xp_ice / xp_max_ice * 100;
      }
      else
      {
         xp_bar_ice.bar.gotoAndStop(2);
         xp_bar_ice.bar._width = 100;
      }
   }
}
function updateRankSnot(amt)
{
   xp = g_width / 2;
   yp = g_ground / 2;
   if(g_rank_snot < 6)
   {
      if((xp_snot += amt) > xp_max_snot)
      {
         xp_snot -= xp_max_snot;
         g_rank_snot++;
         xp_max_snot = g_rank_snot * g_rank_factor;
         var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
         _loc1_._x = xp;
         _loc1_._y = yp;
         _loc1_.val = "snot level up!";
         playSound("level_up03.wav");
      }
      if(g_rank_snot < 6)
      {
         xp_bar_snot.bar._width = xp_snot / xp_max_snot * 100;
      }
      else
      {
         xp_bar_snot.bar.gotoAndStop(2);
         xp_bar_snot.bar._width = 100;
      }
   }
}
function updateRankGreese(amt)
{
   xp = g_width / 2;
   yp = g_ground / 2;
   if(g_rank_greese < 6)
   {
      if((xp_greese += amt) > xp_max_greese)
      {
         xp_greese -= xp_max_greese;
         g_rank_greese++;
         xp_max_greese = g_rank_greese * g_rank_factor;
         var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
         _loc1_._x = xp;
         _loc1_._y = yp;
         _loc1_.val = "grease level up!";
         playSound("level_up03.wav");
      }
      if(g_rank_greese < 6)
      {
         xp_bar_greese.bar._width = xp_greese / xp_max_greese * 100;
      }
      else
      {
         xp_bar_greese.bar.gotoAndStop(2);
         xp_bar_greese.bar._width = 100;
      }
   }
}
function updateRankMeteor(amt)
{
   xp = g_width / 2;
   yp = g_ground / 2;
   if(g_rank_meteor < 6)
   {
      if((xp_meteor += amt) > xp_max_meteor)
      {
         xp_meteor -= xp_max_meteor;
         g_rank_meteor++;
         xp_max_meteor = g_rank_meteor * g_rank_factor;
         var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
         _loc1_._x = xp;
         _loc1_._y = yp;
         _loc1_.val = "meteor level up!";
         playSound("level_up03.wav");
      }
      if(g_rank_meteor < 6)
      {
         xp_bar_meteor.bar._width = xp_meteor / xp_max_meteor * 100;
      }
      else
      {
         xp_bar_meteor.bar.gotoAndStop(2);
         xp_bar_meteor.bar._width = 100;
      }
   }
}
function getReflectionAngle(ang, pvx, pvy)
{
   var _loc12_ = Math.cos(0.017453292519943295 * ang) * 100;
   var _loc11_ = Math.sin(0.017453292519943295 * ang) * 100;
   var _loc17_ = 0;
   var _loc16_ = 0;
   var _loc5_ = - _loc12_;
   var _loc9_ = - _loc11_;
   var _loc1_ = _loc12_ + _loc5_ / 2;
   var _loc4_ = _loc11_ + _loc9_ / 2;
   var _loc8_ = _loc1_ - pvx;
   var _loc10_ = _loc4_ - pvy;
   var _loc3_ = _loc8_ - _loc1_;
   var _loc6_ = _loc10_ - _loc4_;
   var _loc22_ = Math.sqrt(_loc3_ * _loc3_ + _loc6_ * _loc6_);
   var _loc2_ = 0;
   if(_loc5_ < 0)
   {
      _loc2_ = 57.29577951308232 * Math.atan(_loc9_ / _loc5_);
   }
   else
   {
      _loc2_ = 180 + 57.29577951308232 * Math.atan(_loc9_ / _loc5_);
   }
   var _loc13_ = _loc2_ - 90;
   var _loc14_ = 0;
   if(_loc3_ > 0)
   {
      _loc14_ = 57.29577951308232 * Math.atan(_loc6_ / _loc3_);
   }
   else
   {
      _loc14_ = 180 + 57.29577951308232 * Math.atan(_loc6_ / _loc3_);
   }
   var _loc18_ = _loc1_ + Math.cos(0.017453292519943295 * _loc13_) * 10;
   var _loc19_ = _loc4_ + Math.sin(0.017453292519943295 * _loc13_) * 10;
   var _loc15_ = getAngleBetweenVectors(_loc1_,_loc4_,_loc17_,_loc16_,_loc8_,_loc10_);
   var _loc20_ = getAngleBetweenVectors(_loc1_,_loc4_,_loc8_,_loc10_,_loc18_,_loc19_);
   var _loc7_ = 0;
   if(_loc20_ > 90)
   {
      _loc7_ = _loc2_ + _loc15_;
   }
   else
   {
      _loc7_ = _loc2_ - _loc15_;
   }
   return _loc7_;
}
function getAngleBetweenVectors(x1, y1, x2, y2, x3, y3)
{
   var _loc3_ = x2 - x1;
   var _loc2_ = y2 - y1;
   var _loc1_ = x3 - x1;
   var _loc4_ = y3 - y1;
   var _loc5_ = _loc3_ * _loc1_ + _loc2_ * _loc4_;
   var _loc7_ = Math.sqrt(_loc3_ * _loc3_ + _loc2_ * _loc2_);
   var _loc6_ = Math.sqrt(_loc1_ * _loc1_ + _loc4_ * _loc4_);
   return 57.29577951308232 * Math.acos(_loc5_ / (_loc7_ * _loc6_));
}
function smartRotation(currentRotation, targetRotation, rotationAmount)
{
   if(Math.abs(currentRotation - targetRotation) <= rotationAmount)
   {
      currentRotation = targetRotation;
   }
   else if(currentRotation != targetRotation)
   {
      if(currentRotation >= 0 && targetRotation >= 0)
      {
         if(currentRotation > targetRotation)
         {
            currentRotation -= rotationAmount;
         }
         else if(currentRotation < targetRotation)
         {
            currentRotation += rotationAmount;
         }
      }
      else if(currentRotation < 0 && targetRotation < 0)
      {
         if(currentRotation > targetRotation)
         {
            currentRotation -= rotationAmount;
         }
         else if(currentRotation < targetRotation)
         {
            currentRotation += rotationAmount;
         }
      }
      else if(currentRotation < 0 && targetRotation >= 0)
      {
         if(Math.abs(currentRotation) + Math.abs(targetRotation) <= 180)
         {
            currentRotation += rotationAmount;
         }
         else if(Math.abs(currentRotation) + Math.abs(targetRotation) > 180)
         {
            currentRotation -= rotationAmount;
         }
      }
      else if(currentRotation >= 0 && targetRotation < 0)
      {
         if(Math.abs(currentRotation) + Math.abs(targetRotation) < 180)
         {
            currentRotation -= rotationAmount;
         }
         else if(Math.abs(currentRotation) + Math.abs(targetRotation) >= 180)
         {
            currentRotation += rotationAmount;
         }
      }
   }
   return currentRotation;
}
function getRotationDirection(currentRotation, targetRotation, rotationAmount)
{
   dir = 0;
   if(Math.abs(currentRotation - targetRotation) <= rotationAmount)
   {
      dir = 0;
   }
   else if(currentRotation != targetRotation)
   {
      if(currentRotation >= 0 && targetRotation >= 0)
      {
         if(currentRotation > targetRotation)
         {
            dir = -1;
         }
         else if(currentRotation < targetRotation)
         {
            dir = 1;
         }
      }
      else if(currentRotation < 0 && targetRotation < 0)
      {
         if(currentRotation > targetRotation)
         {
            dir = -1;
         }
         else if(currentRotation < targetRotation)
         {
            dir = 1;
         }
      }
      else if(currentRotation < 0 && targetRotation >= 0)
      {
         if(Math.abs(currentRotation) + Math.abs(targetRotation) <= 180)
         {
            dir = 1;
         }
         else if(Math.abs(currentRotation) + Math.abs(targetRotation) > 180)
         {
            dir = -1;
         }
      }
      else if(currentRotation >= 0 && targetRotation < 0)
      {
         if(Math.abs(currentRotation) + Math.abs(targetRotation) < 180)
         {
            dir = -1;
         }
         else if(Math.abs(currentRotation) + Math.abs(targetRotation) >= 180)
         {
            dir = 1;
         }
      }
   }
   return dir;
}
function nextLevel()
{
   g_level++;
   var _loc1_ = addObj("xp_text",score_layer,getNextScoreLevel());
   _loc1_._x = g_width / 2;
   _loc1_._y = g_ground / 2;
   _loc1_.val = "Level " + g_level + "!";
   playSound("level_up.wav");
}
function addScore(amt, xp, yp)
{
   g_score += amt;
   var _loc1_ = addObj("dmg_text",score_layer,getNextScoreLevel());
   _loc1_._x = xp;
   _loc1_._y = yp;
   _loc1_.val = "" + amt;
}
function playSound(filename)
{
   if(g_soundOn)
   {
      mysound = new Sound();
      mysound.attachSound(filename);
      mysound.start(0,1);
   }
}
function loadOptions()
{
   g_halted = true;
   g_paused = true;
   g_window = addObj("window_options",window_layer,1);
}
function closeOptions()
{
   g_halted = false;
   g_paused = false;
   updatePauseText();
   g_window.unloadMovie();
}
function loadSponsors()
{
   g_halted = true;
   g_paused = true;
   g_window = addObj("window_sponsors",window_layer,1);
}
function closeSponsors()
{
   loadOptions();
}
function loadHighScores()
{
   g_halted = true;
   g_paused = true;
   g_window = addObj("window_scores",window_layer,1);
}
function closeHighScores()
{
   loadOptions();
}
function toggleSound()
{
   if(g_soundOn)
   {
      g_soundOn = false;
      g_sound_text = "sound: off";
   }
   else
   {
      g_soundOn = true;
      g_sound_text = "sound: on";
   }
}
function loadGameGuide()
{
   getUrl("http://www.lostvectors.com/dragon/guide.html", "_blank");
}
function loadUpdates()
{
   g_halted = true;
   g_paused = true;
   g_window = addObj("window_updates",window_layer,1);
}
function gameOver()
{
   updatedTopScores();
   g_halted = true;
   g_paused = true;
   g_window = addObj("window_game_over",window_layer,1);
}
function loadGlobalScores()
{
   getUrl("http://www.lostvectors.com/dragon/high_scores.html", "_blank");
}
function resetGame()
{
   _root.gotoAndPlay("start_game");
}
function saveData()
{
   myLocalSO.data.place_score_1 = _root.place_score_1;
   myLocalSO.data.place_score_2 = _root.place_score_2;
   myLocalSO.data.place_score_3 = _root.place_score_3;
   myLocalSO.data.place_name_1 = _root.place_name_1;
   myLocalSO.data.place_name_2 = _root.place_name_2;
   myLocalSO.data.place_name_3 = _root.place_name_3;
   myLocalSO.data.player_name = _root.player_name;
}
function updatedTopScores()
{
   var _loc2_ = g_score;
   if(_loc2_ > _root.place_score_1)
   {
      _root.place_score_3 = _root.place_score_2;
      _root.place_score_2 = _root.place_score_1;
      _root.place_score_1 = _loc2_;
      _root.place_name_3 = _root.place_name_2;
      _root.place_name_2 = _root.place_name_1;
      _root.place_name_1 = _root.player_name;
      _root.end_text = "New high score! 1st Place";
   }
   else if(_loc2_ > _root.place_score_2)
   {
      _root.place_score_3 = _root.place_score_2;
      _root.place_score_2 = _loc2_;
      _root.place_name_3 = _root.place_name_2;
      _root.place_name_2 = _root.player_name;
      _root.end_text = "New high score! 2nd Place";
   }
   else if(_loc2_ > _root.place_score_3)
   {
      _root.place_score_3 = _loc2_;
      _root.place_name_3 = _root.player_name;
      _root.end_text = "New high score! 3rd Place";
   }
   else if(_loc2_ > 500000)
   {
      _root.end_text = "Hail his majesty! King of the night sky! Your reign of terror will not soon be forgotten!";
   }
   else if(_loc2_ > 100000)
   {
      _root.end_text = "Hail the dragon prince of terror!";
   }
   else if(_loc2_ > 50000)
   {
      _root.end_text = "You are a fearsome dragon!";
   }
   else if(_loc2_ > 30000)
   {
      _root.end_text = "You\'re gaining the respect of your enemies.";
   }
   else if(_loc2_ > 10000)
   {
      _root.end_text = "Ouch... maybe you should try out as a good-luck dragon.";
   }
   else
   {
      _root.end_text = "Noob Tip: use mouse-left click to fire :P";
   }
   saveData();
}
function updatePauseText()
{
   if(g_paused)
   {
      g_pause_text = "play";
   }
   else
   {
      g_pause_text = "pause";
   }
}
var g_version = "1.0.1.4";
var KEY_W = 87;
var KEY_E = 69;
var KEY_Q = 81;
var KEY_A = 65;
var KEY_S = 83;
var KEY_D = 68;
var KEY_X = 67;
var KEY_C = 88;
var KEY_J = 74;
var KEY_K = 75;
var KEY_L = 76;
var KEY_U = 85;
var KEY_SPACEBAR = 32;
var FIRE_MODE = 1;
var ICE_MODE = 2;
var METEOR_MODE = 3;
var SNOT_MODE = 4;
var GREESE_MODE = 5;
var STEEL_MODE = 6;
var g_grav = 0.1;
var max_ndx = 140;
var yspine = new Array(max_ndx);
var xspine = new Array(max_ndx);
var rotspin = new Array(max_ndx);
var ztwist = new Array(max_ndx);
var enemies = new Array();
var m_dragonParts = new Array();
var g_paused = false;
var g_halted = false;
var g_pause_text = "pause";
var g_window = null;
var sndx = 0;
var in_speed = 2.2;
var d_speed = in_speed;
var d_turn_rate = d_speed * 0.3;
var factor = 5;
var pulling = false;
var shot_fired = false;
var g_width = 728;
var g_ground = 500;
var someListener = new Object();
someListener.onMouseDown = function()
{
   pulling = true;
   shot_fired = false;
};
Mouse.addListener(someListener);
var someListener2 = new Object();
someListener2.onMouseUp = function()
{
   pulling = false;
};
Mouse.addListener(someListener2);
var g_dragon_hp = 100;
var g_dragon_max_hp = 100;
var g_ammo_fire = 100;
var g_ammo_ice = 100;
var g_ammo_meteor = 100;
var g_ammo_snot = 100;
var g_ammo_steel = 100;
var g_ammo_greese = 100;
var g_rank_snot = 1;
var xp_snot;
var xp_max_snot;
var g_rank_fire = 1;
var xp_fire;
var xp_max_fire;
var g_rank_ice = 1;
var xp_ice;
var xp_max_ice;
var g_rank_steel = 1;
var xp_steel;
var xp_max_steel;
var g_rank_greese = 1;
var xp_greese;
var xp_max_greese;
var g_rank_meteor = 1;
var xp_meteor;
var xp_max_meteor;
var g_levelTimer = 0;
var g_level = 1;
var g_score = 0;
var g_rank_factor = 1000;
var g_dmg_text_on = false;
var g_sound_text = "sound: on";
var g_soundOn = true;
initGameVars();
var g_shoot_mode = FIRE_MODE;
var g_shoot_mode_text = "fire ball";
fire_button.gotoAndStop(2);
var plankDebris = new Array("deb_plank_1","deb_plank_2","deb_plank_3","deb_plank_4");
var g_steel_balls = new Array();
proj_lvl = 1;
sticky_lvl = 1;
var id_num = 2;
var ene_lvl = 1;
var debris_lvl = 1;
var ammo_lvl = 1;
var score_lvl = 1;
_root.place_score_1 = 30000;
_root.place_score_2 = 20000;
_root.place_score_3 = 10000;
_root.place_name_1 = "Falkor";
_root.place_name_2 = "Onyxia";
_root.place_name_3 = "Smaug";
_root.player_name = "noob";
myLocalSO = SharedObject.getLocal("rd002");
if(myLocalSO.data.place_score_1 != null)
{
   _root.place_score_1 = myLocalSO.data.place_score_1;
   _root.place_score_2 = myLocalSO.data.place_score_2;
   _root.place_score_3 = myLocalSO.data.place_score_3;
   _root.place_name_1 = myLocalSO.data.place_name_1;
   _root.place_name_2 = myLocalSO.data.place_name_2;
   _root.place_name_3 = myLocalSO.data.place_name_3;
   _root.player_name = myLocalSO.data.player_name;
}
else
{
   _root.first_time_playing = true;
   _root.place_score_1 = 30000;
   _root.place_score_2 = 20000;
   _root.place_score_3 = 10000;
   _root.place_name_1 = "Falkor";
   _root.place_name_2 = "Onyxia";
   _root.place_name_3 = "Smaug";
   _root.player_name = "noob";
}
